module Main where

import CFG
import qualified Data.Set as S
import Data.List
import Data.Tree
import Data.Ord

compareList f [] [] = EQ
compareList f _ [] = GT
compareList f [] _ = LT
compareList f (x:xs) (y:ys) = if (f x y) /= EQ then f x y else compareList f xs ys

compareTree :: Tree Symbol -> Tree Symbol -> Ordering
compareTree (Node x ts) (Node y ts') = if x /= y then compare (show x) (show y) else compareList compareTree ts ts'

drawTree' :: Tree Symbol -> String
drawTree' = unlines . draw

draw :: Tree Symbol -> [String]
draw (Node x ts) = show x : drawSubTrees ts
  where 
    drawSubTrees [] = []
    drawSubTrees [t] = 
      shift "└" " " (draw t)
    drawSubTrees (t:ts) = 
      shift "├" "│" (draw t) ++ drawSubTrees ts
    shift first other = zipWith (++) (first : repeat other)

-- TODO: Implement this function
showDerivationTrees :: CFG -> [Symbol] -> String
showDerivationTrees g w = ""

chunksOf1 :: [a] -> [[a]]
chunksOf1 [] = []
chunksOf1 l = (take 1 l) : chunksOf1 (drop 1 l)
  
main =
  do g <- fmap (parseCFG . map trim) readLines
     w <- fmap (map (parseSymbol (S.toList (nonterminals g)) (S.toList (alphabet g))) . chunksOf1 . trim) getLine
     putStrLn (showDerivationTrees g w)
  where readLines = do {s <- getLine; if s == "END" then return [] else fmap (s:) readLines}

