
/**
 * Represents a symbol, i.e. something that is either a terminal or a non-terminal.
 */
public abstract class Symbol implements Comparable<Symbol> {
	
	public abstract String getName();

	public String toString() {
		return getName();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + getName().hashCode();
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Symbol other = (Symbol) obj;
		return getName().equals(other.getName());
	}

	@Override
	public int compareTo(Symbol o) {
		return getName().compareTo(o.getName());
	}
	
}
